		#include        p12f1572.inc

                __CONFIG   _CONFIG1, _CLKOUTEN_OFF & _CP_OFF & _BOREN_ON & _MCLRE_OFF & _PWRTE_OFF & _WDTE_ON & _FOSC_INTOSC
                __CONFIG   _CONFIG2, _LVP_OFF & _PLLEN_OFF

                                ;Code for GPS mouse 1.0
                                 
                                ;********************
                                ;Still to do:
				;Only transmit on valid data received*DONE
				;TEST:
                                ;********************

;PIN	1	vdd
;PIN	2	RA5	DI	RXD
;PIN	3	RA4	DO	TXD	
;PIN	4	RA3	DI	NA
;PIN	5	RA2	DI	NA		
;PIN	6	RA1	DO	LED
;PIN	7	RA0	DI	NA
;PIN	8	vss

;-----------------------------                                
;I/O data from OS for user program found from 60-7fh BANK 00000000000000000000000000000000000
;-----------------------------

GPSCH			equ	0x71	;checksum MSN
GPSCL			equ	0x72	;checksum LSN
Tcount			equ	0x73	;Number of transmits in a row
GPStemp1		equ	0x76	;temp buffer for GPS data
GPStemp2		equ	0x77	;temp buffer for GPS data
		
GPStemp3		equ	0x78	;temp buffer for checksum data
GPStemp4		equ	0x79	;temp buffer for checksum data		
Tick			equ	0x7a	;1/250 sec tick
Seck			equ	0x7b	;Seconds
TempCounP1a		equ	0x7c	;Temp counter
INTflags		equ	0x7d	;Software flag Bit 7 - Apply live brightness changes to tubes
					;Software flag Bit 6 - Disable rec packet 0
					;Software flag Bit 5 - Disable rec packet 1
					;Software flag Bit 4 - Disable IR transmit
					;Software flag Bit 3 - Set every second
					;Software flag Bit 2 - Disable transition effects
					;Software flag Bit 1 - Force display load incl transition buffer
					;Software flag Bit 0 - Set 4 times/sec

GPSpoint		equ	0x7e	;Pointer for GPS data buffer
SELflags		equ	0x7f	;Software flag Bit 7 - GPS data string ready
					;Software flag Bit 6 - GPS string being received

;#########################################################################################################
;								START OF CODE
;#########################################################################################################

				org 0x00

		goto	Inity			;Reset vector

				org 0x04

		banksel	PORTA

		btfsc	PIR1,5
		goto	GPSRXD			;RXD from IR/GPS

		btfsc	PIR1,1
		goto	Timr6			;Timer 2 Interrupt - RTC

		retfie

;--------------------------------------------------------------------------------------------------------
Timr6							;Timer 1 interrupt, set 1/100 flag
;--------------------------------------------------------------------------------------------------------

		clrwdt
		incf	Tick,f
		movlw	.254
		xorwf	Tick,w
		btfss	STATUS,Z
		goto	mainsexit
		clrf	Tick
increment_secs	
		incf	Seck,f
mainsexit					;Reload counter for next interrupt
		bcf	PIR1,1 			;clear timer 1 int
		retfie

;--------------------------------------------------------------------------------------------------------
GPSRXD							;Read incoming RXD byte from GPS
;--------------------------------------------------------------------------------------------------------

				;bsf	PORTA,1
				
		BANKSEL	RCREG
		movf	RCREG,w
		movwf	GPStemp1
		andlw	0x1f
		movwf	GPStemp4
		btfsc	SELflags,7			;Exit if string ready to process
		goto	GPSRXDex
		btfsc	SELflags,6			;bypass if already receiving a string
		goto	GPSRXDin

		movlw	"$"				;Look for start byte
		xorwf	GPStemp1,w
		btfss	STATUS,Z
		goto	GPSRXDex			;Not start,exit
		movlw	0x0	
		movwf	GPSpoint			;Setup buffer pointer
		bsf	SELflags,6			;Flag string to receive
		goto	GPSRXDex			;Exit ready to receive on next byte

GPSRXDin
		movlw	0x20
		movwf	FSR0H
		movf	GPSpoint,w
		movwf	FSR0L
		movf	GPStemp1,w
		movwf	INDF0
		incf	GPSpoint,f
		movlw	.200				;Look for start byte
		xorwf	GPSpoint,w
		btfsc	STATUS,Z
		goto	GPSRXDerrr			;No stop before end of buffer, discard data and reset

		decf	FSR0L,f
		decf	FSR0L,f
		movf	INDF0,w
		movwf	GPStemp1
		movlw	"*"				;Look for end byte
		xorwf	GPStemp1,w
		btfss	STATUS,Z
		goto	GPSRXDex;3			;No stop byte, exit.
		bcf	SELflags,6			;Clear data being received flag
		bsf	SELflags,7			;Replace with data ready flag
		goto	GPSRXDex

GPSRXDerrr						;Buffer pointer overflowed with no * detected
		bcf	SELflags,7
		bcf	SELflags,6

GPSRXDex
		BANKSEL	PORTA
				bcf	PORTA,1
		bcf	PIR1,5
		retfie

;****************************************************************************************************

Inity						;Initialise registers
		clrwdt

Coldstart
		movlw	0x20
		movwf	FSR0L
		clrf	FSR0H
Init1
		nop
		clrf	INDF0
		incf	FSR0L,f
		btfss	FSR0L,7
		clrf	PORTA
		clrf	Tcount

;------------------------------------------------------------

Warmstart
;Set I/O pins
		BANKSEL	OSCCON
		movlw	b'01111000'
		movwf	OSCCON
;Set ADC controls
		BANKSEL	ANSELA
		clrf	ANSELA			;Weird DO fault?

		BANKSEL	TRISA
		movlw	b'11101101'
		movwf	TRISA

		movlw	b'10000100'
		movwf	OPTION_REG		;Timer 0 1:32 prescaler

		BANKSEL	WPUA
		clrf	WPUA			;no pullups		
		BANKSEL	APFCON
		movlw	b'10000100'
		movwf	APFCON

		BANKSEL	PORTA
;Setup Timer2
		movlw	b'00000111'		;T2 on, 1:1 prescaler
		movwf	T2CON
		BANKSEL	PIE1
		bsf	PIE1,1
		BANKSEL	TMR2
		movlw	.250
		movwf	TMR2
		bsf	INTCON,6		;Interrupts enabled
		
;Setup RXD for GPS data
		BANKSEL	BAUDCON
		movlw	.25			;2400=103, 9600=25
		movwf	SPBRGL	
		movlw	b'10010000'		;Enable serial, RXD
		movwf	RCSTA
		movlw	b'00000000'		;Enable 16 bit BRG
		movwf	TXSTA
		BANKSEL	PIE1
		bsf	PIE1,5			;Enable RXD interrupts
		BANKSEL	PCON
		bsf	PCON,1			;Set Power on flag
		BANKSEL	PORTA
		
		bcf	PORTA,1

;--------------------------------------------------------------------------------------------------------
MainStart						;Refresh display loop and menu - everything else on interrupts
;--------------------------------------------------------------------------------------------------------
		;call	zxc
		bsf	INTCON,7
		call	checkk
		goto	MainStart

;--------------------------------------------------------------------------------------------------------
checkk							;Check INTflags
;--------------------------------------------------------------------------------------------------------

		btfsc	INTflags,3		;Check flag to call once a second
		call	Call1
		btfsc	SELflags,7		;Check if GPS data received
		call	GPSdecode
		return

;--------------------------------------------------------------------------------------------------------
Call1							;Run once a sec, from main program loop - display tree
;--------------------------------------------------------------------------------------------------------

TXDGENLo						;Return point from page 1
		bsf	INTCON,7
		bcf	INTflags,3
		bcf	INTflags,1
		return

;--------------------------------------------------------------------------------------------------------
GPSdecode						;Verify GPS data string and extract time/date
;--------------------------------------------------------------------------------------------------------

		clrf	GPStemp1		;Set up registers
		movlw	0x20
		movwf	FSR0H
		movlw	0x00
		movwf	FSR0L

GPSreri
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	GPSrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	GPSrerend		
GPSreBend
		movf	INDF0,w
		xorwf	GPStemp1,f		;XOR current byte, increment pointer and loop
		incf	FSR0L,f
		goto	GPSreri
GPSrerend
		incf	FSR0L,f
		incf	FSR0L,f			;Increment to LSB of checksum
		movf	INDF0,w
		sublw	0x40			;Subtract 0x40 - will overflow if it's a number
		btfsc	STATUS,C
		goto	GPSmsblo1		;Yes, it's a number
		movlw	.55			;It's a letter, A-F
		subwf	INDF0,w
		goto	GPSrerend1
GPSmsblo1
		movlw	0x30
		subwf	INDF0,w		
GPSrerend1
		andlw	0x0f
		movwf	GPSpoint
		swapf	GPSpoint,f		;Swap to high nibble
		decf	FSR0L,f			;Get MSB
		movf	INDF0,w
		sublw	0x40			;Subtract 0x40 - overflow?
		btfsc	STATUS,C
		goto	GPSmsblo2		;Yes, it's a number
		movlw	.55
		subwf	INDF0,w
		goto	GPSmsblo2a
GPSmsblo2
		movlw	0x30
		subwf	INDF0,w
GPSmsblo2a
		andlw	0x0f
		iorwf	GPSpoint,f		;Add both nibbles
		swapf	GPSpoint,f		;and swap the right way round

		movf	GPSpoint,w		;Compare checksums
		xorwf	GPStemp1,w
		btfss	STATUS,Z
		goto	GPSdecodeX		;Bytes don't match

;We have a valid string, now extract the data we need from it
;$GPRMC,092751.000,A,5321.6802,N,00630.3371,W,0.06,31.66,280511,,,A*45		

		movlw	0x02
		movwf	FSR0L
		movlw	"R"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"M"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeX		;Not the string we want, exit
		incf	FSR0L,f
		movlw	"C"
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeX		;Not the string we want, exit
		incf	FSR0L,f			;Move on to ','
		
GPSdecodeVoid	
		incf	FSR0L,f			;And pass the time...
		movlw	","
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeVoid		;Not a comma yet
		
		incf	FSR0L,f
		movlw	"A"			;Is the data live?
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeX		;Not the string we want, exit
		
;Is it time for a send string?
		bsf	PORTA,1			;Flash LED
		btfsc	Tcount,7
		goto	GPSdecodesend1		;Startup burst completed, just once a minute or so
		incf	Tcount,f
		goto	GPSdecodesend
		
GPSdecodesend1	
		btfss	Seck,7
		goto	GPSdecodeX		;Not time yet
		clrf	Seck	
GPSdecodesend		
		call	GPSrelay		;Code send here

GPSdecodeX					;Exit point
		bcf	SELflags,7		;Check if GPS data received
		BANKSEL	PORTA	

		bsf	INTCON,7
		return

;--------------------------------------------------------------------------------------------------------		
GPSrelay
;--------------------------------------------------------------------------------------------------------
		
		movlw	0x20
		movwf	FSR0H
		movwf	FSR1H
		movlw	0x0a
		movwf	FSR0L			;Set to point after time data
		movlw	.210
		movwf	FSR1L
		
		movlw	0x08
		movwf	TempCounP1a		;count ,s
GPSdecodeloop					;Now look for the date data
		incf	FSR0L,f
		movlw	","
		xorwf	INDF0,w
		btfss	STATUS,Z
		goto	GPSdecodeloop		;Not the comma, looop
		decfsz	TempCounP1a,f
		goto	GPSdecodeloop		;Not the LAST comma, looop
		incf	FSR0L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f		
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF0,w
		movwf	INDF1
		incf	FSR0L,f		
		incf	FSR1L,f			;6 bytes of date moved
		
		movlw	.12
		movwf	FSR0L			;Set to point after time data
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	"A"	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	","
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movwf	INDF0
		incf	FSR0L,f	
		movlw	.210
		movwf	FSR1L
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f			
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f		
		incf	FSR1L,f	
		
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	","	
		movwf	INDF0
		incf	FSR0L,f	
		
		movlw	"A"	
		movwf	INDF0
		incf	FSR0L,f	

		movlw	"*"	
		movwf	INDF0
		
		clrf	GPStemp1		;Calculate new checksum
		movlw	0x20
		movwf	FSR0H
		movlw	0x00
		movwf	FSR0L

GPSCreri
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	GPSCrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	GPSCrerend		
GPSCreBend
		movf	INDF0,w
		xorwf	GPStemp1,f		;XOR current byte, increment pointer and loop
		incf	FSR0L,f
		goto	GPSCreri
		
GPSCrerend	
		incf	FSR0L,f
		movf	GPStemp1,w
		andlw	0x0f			;lower nybble
		movwf	GPSCL
		swapf	GPStemp1,w
		andlw	0x0f			;higher nybble
		movwf	GPSCH
		
		sublw	.9
		btfsc	STATUS,C
		goto	GPSCchk1
		movlw	.55
		goto	GPSCchk2
GPSCchk1	
		movlw	0x30
GPSCchk2		
		addwf	GPSCH,f
		
		movf	GPSCL,w
		sublw	.9
		btfsc	STATUS,C
		goto	GPSCchk11
		movlw	.55
		goto	GPSCchk12
GPSCchk11	
		movlw	0x30
GPSCchk12		
		addwf	GPSCL,f	
		
		movf	GPSCH,w
		movwf	INDF0
		incf	FSR0L,f
		movf	GPSCL,w
		movwf	INDF0
		incf	FSR0L,f	
zxc
		bcf	INTCON,7		;Setup serial port for send
		bsf	PORTA,1
		BANKSEL	BAUDCON			;Set baud rate to 2400
		bcf	RCSTA,4			;disable rxd
		bsf	TXSTA,5
		movlw	.103			;2400=103, 9600=25
		movwf	SPBRGL
		
		call	GPSsend
		call	GPSsend
	;	call	GPSsend
		
		BANKSEL	BAUDCON			;Return baud rate to 9600
		movlw	.25			;2400=103, 9600=25
		movwf	SPBRGL	
		bcf	RCSTA,1
		bsf	RCSTA,4
		bcf	TXSTA,5
		BANKSEL	PORTA
		bcf	PIR1,5
		bsf	INTCON,7
		return
		
GPSsend		;Now send the rebuilt string at 2400bps		
		
		movlw	"$"
		movwf	TXREG
		nop
GPSR4		btfss	TXSTA,1
		goto	GPSR4			

		movlw	0x20			;Transmit string
		movwf	FSR0H
		movlw	0x00
		movwf	FSR0L
		bsf	PORTA,1
GPSRreri
		movf	INDF0,w
		movwf	TXREG
		nop
GPSR5		btfss	TXSTA,1
		goto	GPSR5		
			
		movlw	"*"
		xorwf	INDF0,w
		btfsc	STATUS,Z
		goto	GPSRrerend		;Last byte found,exit

		movlw	.200			;End of buffer
		xorwf	FSR0L,w
		btfsc	STATUS,Z
		goto	GPSRrerend		
GPSRreBend
		incf	FSR0L,f
		goto	GPSRreri
		
GPSRrerend
		incf	FSR0L,f
		movf	INDF0,w
		movwf	TXREG
		nop
GPSR11		btfss	TXSTA,1
		goto	GPSR11	
		
		incf	FSR0L,f
		movf	INDF0,w
		movwf	TXREG
		nop
GPSR12		btfss	TXSTA,1
		goto	GPSR12
		
		
		movlw	.13
		movwf	TXREG
		nop
GPSR55		btfss	TXSTA,1
		goto	GPSR55
		
		movlw	.10
		movwf	TXREG
		nop
GPSR56		btfss	TXSTA,1
		goto	GPSR56
		return
				
;#####################################################################################################################################

		end

;#####################################################################################################################################
